package fr.drools.serialisation;

import java.util.HashSet;
import java.util.Set;



public class RattachementFils implements IRattachementEnfant {

	private static final String CACHE_KEY_PREFIX = "RattachementFils::";

	private String eventStatus;

	private String idEquipement;



	private String idEquipementPere;

	
	public RattachementFils() {
		super();
	
	}

	
	public String getIdEquipement() {
		return idEquipement;
	}

	
	
	public String getIdEquipementParent() {
		return idEquipementPere;
	}


	public void setIdEquipement(String idEquipement) {
		this.idEquipement = idEquipement;
	}

	
	public String getIdEquipementPere() {
		return idEquipementPere;
	}

	public static String getCacheKey(String typeInformation, String idEquipement) {
		return CACHE_KEY_PREFIX + typeInformation + "_" + idEquipement;
	}

	
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!(obj instanceof RattachementFils)) {
			return false;
		}

		RattachementFils that = (RattachementFils) obj;

		if (!idEquipement.equals(that.idEquipement)) {
			return false;
		}

		if (!idEquipementPere.equals(that.idEquipementPere)) {
			return false;
		}

		return true;
	}



	
	public String getEventStatus() {
		return eventStatus;
	}

	public void setEventStatus(String eventStatus) {
		this.eventStatus = eventStatus;
	}


	public String getTypeElement() {
		return "RATTACHEMENT";
	}


	@Override
	public String toString() {
		return "RattachementFils["+idEquipement+";pere:"+idEquipementPere+"]";
	}
}
