package fr.drools.serialisation.wm;

import java.util.Iterator;
import java.util.ServiceLoader;

public class WorkingMemoryDataFactory {

	private static final Class<? extends WorkingMemoryData> WORKING_MEMORY_DATA_CLASS = discoverClass(WorkingMemoryData.class);

	private WorkingMemoryDataFactory() {
	}

	private static <T> Class<? extends T> discoverClass(Class<T> clazz) {
		ServiceLoader<T> loader = ServiceLoader.load(clazz);
		Iterator<T> iterator = loader.iterator();
		if (iterator.hasNext()) {
			T implementation = iterator.next();
			if (iterator.hasNext()) {
				throw new IllegalStateException("Implémentations multiples trouvées pour " + clazz);
			}
			return (Class<? extends T>) implementation.getClass();
		}
		throw new IllegalStateException("Aucune implémentation trouvée pour " + clazz);
	}

	public static <V extends Versionable> WorkingMemoryData<V> newWorkingMemoryData() {
		try {
			return WORKING_MEMORY_DATA_CLASS.newInstance();
		} catch (ReflectiveOperationException e) {
			throw new IllegalStateException(e);
		}
	}
}
